pcl::BOARDLocalReferenceFrameEstimation< PointInT, PointNT, PointOutT > Class Template Reference
Module features

BOARDLocalReferenceFrameEstimation implements the BOrder Aware Repeatable Directions algorithm for local reference frame estimation as described here: More...

`#include <pcl/features/board.h>`

Inheritance diagram for pcl::BOARDLocalReferenceFrameEstimation< PointInT, PointNT, PointOutT >:

## Public Types

using | Ptr = shared_ptr< BOARDLocalReferenceFrameEstimation< PointInT, PointNT, PointOutT > >
using | ConstPtr = shared_ptr< const BOARDLocalReferenceFrameEstimation< PointInT, PointNT, PointOutT > >
Public Types inherited from pcl::FeatureFromNormals< PointInT, PointNT, PointOutT >
using | PointCloudN = pcl::PointCloud< PointNT >
using | PointCloudNPtr = typename PointCloudN::Ptr
using | PointCloudNConstPtr = typename PointCloudN::ConstPtr
using | Ptr = shared_ptr< FeatureFromNormals< PointInT, PointNT, PointOutT > >
using | ConstPtr = shared_ptr< const FeatureFromNormals< PointInT, PointNT, PointOutT > >
Public Types inherited from pcl::Feature< PointInT, PointOutT >
using | BaseClass = PCLBase< PointInT >
using | Ptr = shared_ptr< Feature< PointInT, PointOutT > >
using | ConstPtr = shared_ptr< const Feature< PointInT, PointOutT > >
using | KdTree = pcl::search::Search< PointInT >
using | KdTreePtr = typename KdTree::Ptr
using | PointCloudIn = pcl::PointCloud< PointInT >
using | PointCloudInPtr = typename PointCloudIn::Ptr
using | PointCloudInConstPtr = typename PointCloudIn::ConstPtr
using | PointCloudOut = pcl::PointCloud< PointOutT >
using | SearchMethod = std::function< int(std::size_t, double, std::vector< int > &, std::vector< float > &)>
using | SearchMethodSurface = std::function< int(const PointCloudIn &cloud, std::size_t index, double, std::vector< int > &, std::vector< float > &)>
Public Types inherited from pcl::PCLBase< PointInT >
using | PointCloud = pcl::PointCloud< PointInT >
using | PointCloudPtr = typename PointCloud::Ptr
using | PointCloudConstPtr = typename PointCloud::ConstPtr
using | PointIndicesPtr = PointIndices::Ptr
using | PointIndicesConstPtr = PointIndices::ConstPtr

## Public Member Functions

| BOARDLocalReferenceFrameEstimation ()
| Constructor. More...
| ~BOARDLocalReferenceFrameEstimation ()
| Empty destructor. More...
void | setTangentRadius (float radius)
| Set the maximum distance of the points used to estimate the x_axis and y_axis of the BOARD Reference Frame for a given point. More...
float | getTangentRadius () const
| Get the maximum distance of the points used to estimate the x_axis and y_axis of the BOARD Reference Frame for a given point. More...
void | setFindHoles (bool find_holes)
| Sets whether holes in the margin of the support, for each point, are searched and accounted for in the estimation of the Reference Frame or not. More...
bool | getFindHoles () const
| Gets whether holes in the margin of the support, for each point, are searched and accounted for in the estimation of the Reference Frame or not. More...
void | setMarginThresh (float margin_thresh)
| Sets the percentage of the search radius (or tangent radius if set) after which a point is considered part of the support margin. More...
float | getMarginThresh () const
| Gets the percentage of the search radius (or tangent radius if set) after which a point is considered part of the support margin. More...
void | setCheckMarginArraySize (int size)
| Sets the number of slices in which is divided the margin for the search of missing regions. More...
int | getCheckMarginArraySize () const
| Gets the number of slices in which is divided the margin for the search of missing regions. More...
void | setHoleSizeProbThresh (float prob_thresh)
| Given the angle width of a hole in the support margin, sets the minimum percentage of a circumference this angle must cover to be considered a missing region in the support and hence used for the estimation of the Reference Frame. More...
float | getHoleSizeProbThresh () const
| Given the angle width of a hole in the support margin, gets the minimum percentage of a circumference this angle must cover to be considered a missing region in the support and hence used for the estimation of the Reference Frame. More...
void | setSteepThresh (float steep_thresh)
| Sets the minimum steepness that the normals of the points situated on the borders of the hole, with reference to the normal of the best point found by the algorithm, must have in order to be considered in the calculation of the Reference Frame. More...
float | getSteepThresh () const
| Gets the minimum steepness that the normals of the points situated on the borders of the hole, with reference to the normal of the best point found by the algorithm, must have in order to be considered in the calculation of the Reference Frame. More...
Public Member Functions inherited from pcl::FeatureFromNormals< PointInT, PointNT, PointOutT >
| FeatureFromNormals ()
| Empty constructor. More...
virtual | ~FeatureFromNormals ()
| Empty destructor. More...
void | setInputNormals (const PointCloudNConstPtr &normals)
| Provide a pointer to the input dataset that contains the point normals of the XYZ dataset. More...
PointCloudNConstPtr | getInputNormals () const
| Get a pointer to the normals of the input XYZ point cloud dataset. More...
Public Member Functions inherited from pcl::Feature< PointInT, PointOutT >
| Feature ()
| Empty constructor. More...
virtual | ~Feature ()
| Empty destructor. More...
void | setSearchSurface (const PointCloudInConstPtr &cloud)
| Provide a pointer to a dataset to add additional information to estimate the features for every point in the input dataset. More...
PointCloudInConstPtr | getSearchSurface () const
| Get a pointer to the surface point cloud dataset. More...
void | setSearchMethod (const KdTreePtr &tree)
| Provide a pointer to the search object. More...
KdTreePtr | getSearchMethod () const
| Get a pointer to the search method used. More...
double | getSearchParameter () const
| Get the internal search parameter. More...
void | setKSearch (int k)
| Set the number of k nearest neighbors to use for the feature estimation. More...
int | getKSearch () const
| get the number of k nearest neighbors used for the feature estimation. More...
void | setRadiusSearch (double radius)
| Set the sphere radius that is to be used for determining the nearest neighbors used for the feature estimation. More...
double | getRadiusSearch () const
| Get the sphere radius used for determining the neighbors. More...
void | compute (PointCloudOut &output)
| Base method for feature estimation for all points given in <setInputCloud (), setIndices ()> using the surface in setSearchSurface () and the spatial locator in setSearchMethod () More...
Public Member Functions inherited from pcl::PCLBase< PointInT >
| PCLBase ()
| Empty constructor. More...
| PCLBase (const PCLBase &base)
| Copy constructor. More...
virtual | ~PCLBase ()
| Destructor. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset. More...
const PointCloudConstPtr | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (std::size_t row_start, std::size_t col_start, std::size_t nb_rows, std::size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud. More...
const IndicesPtr | getIndices ()
| Get a pointer to the vector of indices used. More...
const IndicesConstPtr | getIndices () const
| Get a pointer to the vector of indices used. More...
const PointInT & | operator[] (std::size_t pos) const
| Override PointCloud operator[] to shorten code. More...

## Protected Types

using | PointCloudIn = typename Feature< PointInT, PointOutT >::PointCloudIn
using | PointCloudOut = typename Feature< PointInT, PointOutT >::PointCloudOut

## Protected Member Functions

void | resetData ()
float | computePointLRF (const int &index, Eigen::Matrix3f &lrf)
| Estimate the LRF descriptor for a given point based on its spatial neighborhood of 3D points with normals. More...
void | computeFeature (PointCloudOut &output) override
| Abstract feature estimation method. More...
void | directedOrthogonalAxis (Eigen::Vector3f const &axis, Eigen::Vector3f const &axis_origin, Eigen::Vector3f const &point, Eigen::Vector3f &directed_ortho_axis)
| Given an axis (with origin axis_origin), return the orthogonal axis directed to point. More...
float | getAngleBetweenUnitVectors (Eigen::Vector3f const &v1, Eigen::Vector3f const &v2, Eigen::Vector3f const &axis)
| return the angle (in radians) that rotate v1 to v2 with respect to axis . More...
void | normalDisambiguation (pcl::PointCloud< PointNT > const &normals_cloud, std::vector< int > const &normal_indices, Eigen::Vector3f &normal)
| Disambiguates a normal direction using adjacent normals. More...
void | planeFitting (Eigen::Matrix< float, Eigen::Dynamic, 3 > const &points, Eigen::Vector3f &center, Eigen::Vector3f &norm)
| Compute Least Square Plane Fitting in a set of 3D points. More...
void | projectPointOnPlane (Eigen::Vector3f const &point, Eigen::Vector3f const &origin_point, Eigen::Vector3f const &plane_normal, Eigen::Vector3f &projected_point)
| Given a plane (origin and normal) and a point, return the projection of x on plane. More...
void | randomOrthogonalAxis (Eigen::Vector3f const &axis, Eigen::Vector3f &rand_ortho_axis)
| Given an axis, return a random orthogonal axis. More...
bool | areEquals (float val1, float val2, float zero_float_eps=1E-8f) const
| Check if val1 and val2 are equals. More...
Protected Member Functions inherited from pcl::FeatureFromNormals< PointInT, PointNT, PointOutT >
virtual bool | initCompute ()
| This method should get called before starting the actual computation. More...
Protected Member Functions inherited from pcl::Feature< PointInT, PointOutT >
const std::string & | getClassName () const
| Get a string representation of the name of this class. More...
virtual bool | deinitCompute ()
| This method should get called after ending the actual computation. More...
int | searchForNeighbors (std::size_t index, double parameter, std::vector< int > &indices, std::vector< float > &distances) const
| Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface. More...
int | searchForNeighbors (const PointCloudIn &cloud, std::size_t index, double parameter, std::vector< int > &indices, std::vector< float > &distances) const
| Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface. More...
Protected Member Functions inherited from pcl::PCLBase< PointInT >
bool | initCompute ()
| This method should get called before starting the actual computation. More...
bool | deinitCompute ()
| This method should get called after finishing the actual computation. More...

## Additional Inherited Members

Protected Attributes inherited from pcl::FeatureFromNormals< PointInT, PointNT, PointOutT >
PointCloudNConstPtr | normals_
| A pointer to the input dataset that contains the point normals of the XYZ dataset. More...
Protected Attributes inherited from pcl::Feature< PointInT, PointOutT >
std::string | feature_name_
| The feature name. More...
SearchMethodSurface | search_method_surface_
| The search method template for points. More...
PointCloudInConstPtr | surface_
| An input point cloud describing the surface that is to be used for nearest neighbors estimation. More...
KdTreePtr | tree_
| A pointer to the spatial search object. More...
double | search_parameter_
| The actual search parameter (from either search_radius_ or k_). More...
double | search_radius_
| The nearest neighbors search radius for each point. More...
int | k_
| The number of K nearest neighbors to use for each point. More...
bool | fake_surface_
| If no surface is given, we use the input PointCloud as the surface. More...
Protected Attributes inherited from pcl::PCLBase< PointInT >
PointCloudConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...

## Detailed Description

### template<typename PointInT, typename PointNT, typename PointOutT = ReferenceFrame>
class pcl::BOARDLocalReferenceFrameEstimation< PointInT, PointNT, PointOutT >

BOARDLocalReferenceFrameEstimation implements the BOrder Aware Repeatable Directions algorithm for local reference frame estimation as described here:

- A. Petrelli, L. Di Stefano, "On the repeatability of the local reference frame for partial shape matching", 13th International Conference on Computer Vision (ICCV), 2011

Author
  Alioscia Petrelli (original), Tommaso Cavallari (PCL port)

Definition at line 58 of file board.h.

## Member Typedef Documentation

## ConstPtr

template<typename PointInT, typename PointNT, typename PointOutT = ReferenceFrame>

using pcl::BOARDLocalReferenceFrameEstimation< PointInT, PointNT, PointOutT >::ConstPtr = shared_ptr<const BOARDLocalReferenceFrameEstimation<PointInT, PointNT, PointOutT> >

Definition at line 62 of file board.h.

## PointCloudIn

template<typename PointInT, typename PointNT, typename PointOutT = ReferenceFrame>

using pcl::BOARDLocalReferenceFrameEstimation< PointInT, PointNT, PointOutT >::PointCloudIn = typename Feature<PointInT, PointOutT>::PointCloudIn

protected

Definition at line 233 of file board.h.

## PointCloudOut

template<typename PointInT, typename PointNT, typename PointOutT = ReferenceFrame>

using pcl::BOARDLocalReferenceFrameEstimation< PointInT, PointNT, PointOutT >::PointCloudOut = typename Feature<PointInT, PointOutT>::PointCloudOut

protected

Definition at line 234 of file board.h.

## Ptr

template<typename PointInT, typename PointNT, typename PointOutT = ReferenceFrame>

using pcl::BOARDLocalReferenceFrameEstimation< PointInT, PointNT, PointOutT >::Ptr = shared_ptr<BOARDLocalReferenceFrameEstimation<PointInT, PointNT, PointOutT> >

Definition at line 61 of file board.h.

## Constructor & Destructor Documentation

## BOARDLocalReferenceFrameEstimation()

template<typename PointInT, typename PointNT, typename PointOutT = ReferenceFrame>

pcl::BOARDLocalReferenceFrameEstimation< PointInT, PointNT, PointOutT >::BOARDLocalReferenceFrameEstimation | ( |  | ) |

inline

Constructor.

Definition at line 65 of file board.h.

References pcl::Feature< PointInT, PointOutT >::feature_name_, and pcl::BOARDLocalReferenceFrameEstimation< PointInT, PointNT, PointOutT >::setCheckMarginArraySize().

## ~BOARDLocalReferenceFrameEstimation()

template<typename PointInT, typename PointNT, typename PointOutT = ReferenceFrame>

pcl::BOARDLocalReferenceFrameEstimation< PointInT, PointNT, PointOutT >::~BOARDLocalReferenceFrameEstimation | ( |  | ) |

inline

Empty destructor.

Definition at line 78 of file board.h.

## Member Function Documentation

## areEquals()

template<typename PointInT, typename PointNT, typename PointOutT = ReferenceFrame>

bool pcl::BOARDLocalReferenceFrameEstimation< PointInT, PointNT, PointOutT >::areEquals | ( | float | val1,
|  | float | val2,
|  | float | zero_float_eps = `1E-8f`
| ) |  | const

inline protected

Check if val1 and val2 are equals.

Parameters

  [in] | val1 | first number to check.
  [in] | val2 | second number to check.
  [in] | zero_float_eps | epsilon

Returns
  true if val1 is equal to val2, false otherwise.

Definition at line 327 of file board.h.

## computeFeature()

template<typename PointInT , typename PointNT , typename PointOutT >

void pcl::BOARDLocalReferenceFrameEstimation< PointInT, PointNT, PointOutT >::computeFeature | ( | PointCloudOut & | output | ) |

override protected

Abstract feature estimation method.

Parameters

  [out] | output | the resultant features

Definition at line 592 of file board.hpp.

## computePointLRF()

template<typename PointInT , typename PointNT , typename PointOutT >

float pcl::BOARDLocalReferenceFrameEstimation< PointInT, PointNT, PointOutT >::computePointLRF | ( | const int & | index,
|  | Eigen::Matrix3f & | lrf
| ) |  |

protected

Estimate the LRF descriptor for a given point based on its spatial neighborhood of 3D points with normals.

Parameters

  [in] | index | the index of the point in input_
  [out] | lrf | the resultant local reference frame

Definition at line 197 of file board.hpp.

References pcl::geometry::randomOrthogonalAxis().

## directedOrthogonalAxis()

template<typename PointInT , typename PointNT , typename PointOutT >

void pcl::BOARDLocalReferenceFrameEstimation< PointInT, PointNT, PointOutT >::directedOrthogonalAxis | ( | Eigen::Vector3f const & | axis,
|  | Eigen::Vector3f const & | axis_origin,
|  | Eigen::Vector3f const & | point,
|  | Eigen::Vector3f & | directed_ortho_axis
| ) |  |

protected

Given an axis (with origin axis_origin), return the orthogonal axis directed to point.

Note
  axis must be normalized.

Parameters

  [in] | axis | the axis
  [in] | axis_origin | the axis_origin
  [in] | point | the point towards which the resulting axis is directed
  [out] | directed_ortho_axis | the directed orthogonal axis calculated

Definition at line 49 of file board.hpp.

## getAngleBetweenUnitVectors()

template<typename PointInT , typename PointNT , typename PointOutT >

float pcl::BOARDLocalReferenceFrameEstimation< PointInT, PointNT, PointOutT >::getAngleBetweenUnitVectors | ( | Eigen::Vector3f const & | v1,
|  | Eigen::Vector3f const & | v2,
|  | Eigen::Vector3f const & | axis
| ) |  |

protected

return the angle (in radians) that rotate v1 to v2 with respect to axis .

Parameters

  [in] | v1 | the first vector
  [in] | v2 | the second vector
  [in] | axis | the rotation axis. Axis must be normalized and orthogonal to plane defined by v1 and v2.

Returns
  angle

Definition at line 84 of file board.hpp.

## getCheckMarginArraySize()

template<typename PointInT, typename PointNT, typename PointOutT = ReferenceFrame>

int pcl::BOARDLocalReferenceFrameEstimation< PointInT, PointNT, PointOutT >::getCheckMarginArraySize | ( |  | ) | const

inline

Gets the number of slices in which is divided the margin for the search of missing regions.

Returns
  the number of margin slices.

Definition at line 174 of file board.h.

## getFindHoles()

template<typename PointInT, typename PointNT, typename PointOutT = ReferenceFrame>

bool pcl::BOARDLocalReferenceFrameEstimation< PointInT, PointNT, PointOutT >::getFindHoles | ( |  | ) | const

inline

Gets whether holes in the margin of the support, for each point, are searched and accounted for in the estimation of the Reference Frame or not.

Returns
  The search for holes in the support is enabled/disabled.

Definition at line 119 of file board.h.

## getHoleSizeProbThresh()

template<typename PointInT, typename PointNT, typename PointOutT = ReferenceFrame>

float pcl::BOARDLocalReferenceFrameEstimation< PointInT, PointNT, PointOutT >::getHoleSizeProbThresh | ( |  | ) | const

inline

Given the angle width of a hole in the support margin, gets the minimum percentage of a circumference this angle must cover to be considered a missing region in the support and hence used for the estimation of the Reference Frame.

Returns
  the minimum percentage of a circumference after which a hole is considered in the calculation

Definition at line 196 of file board.h.

## getMarginThresh()

template<typename PointInT, typename PointNT, typename PointOutT = ReferenceFrame>

float pcl::BOARDLocalReferenceFrameEstimation< PointInT, PointNT, PointOutT >::getMarginThresh | ( |  | ) | const

inline

Gets the percentage of the search radius (or tangent radius if set) after which a point is considered part of the support margin.

Returns
  The percentage of the search radius after which a point is considered a margin point.

Definition at line 139 of file board.h.

## getSteepThresh()

template<typename PointInT, typename PointNT, typename PointOutT = ReferenceFrame>

float pcl::BOARDLocalReferenceFrameEstimation< PointInT, PointNT, PointOutT >::getSteepThresh | ( |  | ) | const

inline

Gets the minimum steepness that the normals of the points situated on the borders of the hole, with reference to the normal of the best point found by the algorithm, must have in order to be considered in the calculation of the Reference Frame.

Returns
  threshold that defines if a missing region contains a point with the most different normal.

Definition at line 218 of file board.h.

## getTangentRadius()

template<typename PointInT, typename PointNT, typename PointOutT = ReferenceFrame>

float pcl::BOARDLocalReferenceFrameEstimation< PointInT, PointNT, PointOutT >::getTangentRadius | ( |  | ) | const

inline

Get the maximum distance of the points used to estimate the x_axis and y_axis of the BOARD Reference Frame for a given point.

Returns
  The search radius for x and y axes. If set to 0 the parameter given with setRadiusSearch is used.

Definition at line 97 of file board.h.

## normalDisambiguation()

template<typename PointInT , typename PointNT , typename PointOutT >

void pcl::BOARDLocalReferenceFrameEstimation< PointInT, PointNT, PointOutT >::normalDisambiguation | ( | pcl::PointCloud< PointNT > const & | normals_cloud,
|  | std::vector< int > const & | normal_indices,
|  | Eigen::Vector3f & | normal
| ) |  |

protected

Disambiguates a normal direction using adjacent normals.

Parameters

  [in] | normals_cloud | a cloud of normals used for the calculation
  [in] | normal_indices | the indices of the normals in the cloud that should to be used for the calculation
  [in,out] | normal | the normal to disambiguate, the calculation is performed in place

Definition at line 172 of file board.hpp.

## planeFitting()

template<typename PointInT , typename PointNT , typename PointOutT >

void pcl::BOARDLocalReferenceFrameEstimation< PointInT, PointNT, PointOutT >::planeFitting | ( | Eigen::Matrix< float, Eigen::Dynamic, 3 > const & | points,
|  | Eigen::Vector3f & | center,
|  | Eigen::Vector3f & | norm
| ) |  |

protected

Compute Least Square Plane Fitting in a set of 3D points.

Parameters

  [in] | points | Matrix(nPoints,3) of 3D points coordinates
  [out] | center | centroid of the distribution of points that belongs to the fitted plane
  [out] | norm | normal to the fitted plane

Definition at line 131 of file board.hpp.

## projectPointOnPlane()

template<typename PointInT , typename PointNT , typename PointOutT >

void pcl::BOARDLocalReferenceFrameEstimation< PointInT, PointNT, PointOutT >::projectPointOnPlane | ( | Eigen::Vector3f const & | point,
|  | Eigen::Vector3f const & | origin_point,
|  | Eigen::Vector3f const & | plane_normal,
|  | Eigen::Vector3f & | projected_point
| ) |  |

protected

Given a plane (origin and normal) and a point, return the projection of x on plane.

Equivalent to vtkPlane::ProjectPoint()

Parameters

  [in] | point | the point to project
  [in] | origin_point | a point belonging to the plane
  [in] | plane_normal | normal of the plane
  [out] | projected_point | the projection of the point on the plane

Definition at line 67 of file board.hpp.

## randomOrthogonalAxis()

template<typename PointInT , typename PointNT , typename PointOutT >

void pcl::BOARDLocalReferenceFrameEstimation< PointInT, PointNT, PointOutT >::randomOrthogonalAxis | ( | Eigen::Vector3f const & | axis,
|  | Eigen::Vector3f & | rand_ortho_axis
| ) |  |

protected

Given an axis, return a random orthogonal axis.

Parameters

  [in] | axis | input axis
  [out] | rand_ortho_axis | an axis orthogonal to the input axis and whose direction is random

Definition at line 100 of file board.hpp.

## resetData()

template<typename PointInT, typename PointNT, typename PointOutT = ReferenceFrame>

void pcl::BOARDLocalReferenceFrameEstimation< PointInT, PointNT, PointOutT >::resetData | ( |  | ) |

inline protected

Definition at line 237 of file board.h.

References pcl::BOARDLocalReferenceFrameEstimation< PointInT, PointNT, PointOutT >::setCheckMarginArraySize().

## setCheckMarginArraySize()

template<typename PointInT, typename PointNT, typename PointOutT = ReferenceFrame>

void pcl::BOARDLocalReferenceFrameEstimation< PointInT, PointNT, PointOutT >::setCheckMarginArraySize | ( | int | size | ) |

inline

Sets the number of slices in which is divided the margin for the search of missing regions.

Parameters

  [in] | size | the number of margin slices.

Definition at line 149 of file board.h.

Referenced by pcl::BOARDLocalReferenceFrameEstimation< PointInT, PointNT, PointOutT >::BOARDLocalReferenceFrameEstimation(), and pcl::BOARDLocalReferenceFrameEstimation< PointInT, PointNT, PointOutT >::resetData().

## setFindHoles()

template<typename PointInT, typename PointNT, typename PointOutT = ReferenceFrame>

void pcl::BOARDLocalReferenceFrameEstimation< PointInT, PointNT, PointOutT >::setFindHoles | ( | bool | find_holes | ) |

inline

Sets whether holes in the margin of the support, for each point, are searched and accounted for in the estimation of the Reference Frame or not.

Parameters

  [in] | find_holes | Enable/Disable the search for holes in the support.

Definition at line 108 of file board.h.

Referenced by pcl::Hough3DGrouping< PointModelT, PointSceneT, PointModelRfT, PointSceneRfT >::computeRf().

## setHoleSizeProbThresh()

template<typename PointInT, typename PointNT, typename PointOutT = ReferenceFrame>

void pcl::BOARDLocalReferenceFrameEstimation< PointInT, PointNT, PointOutT >::setHoleSizeProbThresh | ( | float | prob_thresh | ) |

inline

Given the angle width of a hole in the support margin, sets the minimum percentage of a circumference this angle must cover to be considered a missing region in the support and hence used for the estimation of the Reference Frame.

Parameters

  [in] | prob_thresh | the minimum percentage of a circumference after which a hole is considered in the calculation

Definition at line 185 of file board.h.

## setMarginThresh()

template<typename PointInT, typename PointNT, typename PointOutT = ReferenceFrame>

void pcl::BOARDLocalReferenceFrameEstimation< PointInT, PointNT, PointOutT >::setMarginThresh | ( | float | margin_thresh | ) |

inline

Sets the percentage of the search radius (or tangent radius if set) after which a point is considered part of the support margin.

Parameters

  [in] | margin_thresh | the percentage of the search radius after which a point is considered a margin point.

Definition at line 129 of file board.h.

## setSteepThresh()

template<typename PointInT, typename PointNT, typename PointOutT = ReferenceFrame>

void pcl::BOARDLocalReferenceFrameEstimation< PointInT, PointNT, PointOutT >::setSteepThresh | ( | float | steep_thresh | ) |

inline

Sets the minimum steepness that the normals of the points situated on the borders of the hole, with reference to the normal of the best point found by the algorithm, must have in order to be considered in the calculation of the Reference Frame.

Parameters

  [in] | steep_thresh | threshold that defines if a missing region contains a point with the most different normal.

Definition at line 207 of file board.h.

## setTangentRadius()

template<typename PointInT, typename PointNT, typename PointOutT = ReferenceFrame>

void pcl::BOARDLocalReferenceFrameEstimation< PointInT, PointNT, PointOutT >::setTangentRadius | ( | float | radius | ) |

inline

Set the maximum distance of the points used to estimate the x_axis and y_axis of the BOARD Reference Frame for a given point.

Parameters

  [in] | radius | The search radius for x and y axes. If not set or set to 0 the parameter given with setRadiusSearch is used.

Definition at line 87 of file board.h.

The documentation for this class was generated from the following files:

- pcl/features/board.h
- pcl/features/impl/board.hpp